%global import_path github.com/coreos/coreos-baremetal
%global repo coreos-baremetal
%global debug_package %{nil}

Name:		bootcfg
Version:	0.4.2
Release:	2%{?dist}
Summary:	Machine network boot/provision config server
License:	ASL 2.0
URL:		https://%{import_path}
Source0:	https://%{import_path}/archive/v%{version}.tar.gz

BuildRequires: golang
BuildRequires: systemd
%{?systemd_requires}

Requires(pre): shadow-utils

%description
bootcfg is an HTTP and gRPC server that renders Ignition configs, cloud-configs,
iPXE/GRUB network boot configs, and meta-data to boot and provision clusters of
CoreOS machines. Configs can be templated and optionally GPG signed.

# Limit to architectures supported by golang or gcc-go compilers
ExclusiveArch: %{go_arches}
# Use golang or gcc-go compiler depending on architecture
BuildRequires: compiler(golang)

%prep
%setup
# tarball has <repo>-<version> top level dir, not <name>-<version>
# %setup -q -n %{repo}-%{version}

%build
# create a Go workspace with a symlink to builddir source
mkdir -p src/github.com/coreos
ln -s ../../../ src/github.com/coreos/coreos-baremetal
export GOPATH=$(pwd):%{gopath}
export GO15VENDOREXPERIMENT=1
function gobuild { go build -a -ldflags "-w -X github.com/coreos/coreos-baremetal/bootcfg/version.Version=v%{version}" "$@"; }
gobuild -o bin/bootcfg %{import_path}/cmd/bootcfg

%files
%doc README.md CHANGES.md CONTRIBUTING.md LICENSE NOTICE DCO
%{_bindir}/bootcfg
%{_sharedstatedir}/%{name}
%{_unitdir}/%{name}.service

%install
install -d %{buildroot}/%{_bindir}
install -d %{buildroot}%{_sharedstatedir}/%{name}
install -p -m 0755 bin/bootcfg %{buildroot}/%{_bindir}
# systemd service unit
mkdir -p %{buildroot}%{_unitdir}
cp contrib/systemd/%{name}.service %{buildroot}%{_unitdir}/

%pre
getent group bootcfg >/dev/null || groupadd -r bootcfg
getent passwd bootcfg >/dev/null || \
    useradd -r -g bootcfg -s /sbin/nologin bootcfg

%post
%systemd_post bootcfg.service

%preun
%systemd_preun bootcfg.service

%postun
%systemd_postun_with_restart bootcfg.service

%changelog
* Wed Dec 7 2016 <dalton.hubble@coreos.com> - 0.4.2-2
- Copr builder server failed to sign 0.4.2-1
* Wed Dec 7 2016 <dalton.hubble@coreos.com> - 0.4.2-1
- Update systemd service unit
* Sat Dec 3 2016 <dalton.hubble@coreos.com> - 0.4.1-3
- Add missing ldflags which caused bootcfg -version to report wrong version
* Fri Dec 2 2016 <dalton.hubble@coreos.com> - 0.4.1-2
- Fix bootcfg user creation
* Fri Dec 2 2016 <dalton.hubble@coreos.com> - 0.4.1-1
- Initial package
